clear all;
N=13;
OD=13*12;
L=16;
C=10;
D=0;
OD_path=calculate_OD_path;
totalInService=0;
link_use=zeros(L,C,1,6);%layer-1 1-occupy or not; 2-priority class; 3-OD_no; 4-OD path no; 5-finish time; 6-service time;
                              
inService=zeros(OD,5,C);
%inServiceNo=zeros(30,5);
%inReservation=zeros(OD,5,C*buffer,2);
%set the routing table

% mean inter-arrival time is r_cus*delta_cus/(r_cus-1)
% delta_cus1 =1.2/2.2;
% r_cus =2.2;
% delta_cus2=1.2/2.2;
%
% p1=0.2;
% p2=0.8;
% l1=0.571973915102754;
% l2=1.230137688433883;
%Traffic1=[0.8 0.85 0.9 0.95 1 1.05 1.1 1.15  1.2 1.3 1.4 ]*7;
%---------single

%X=[0.8 0.85 0.9 0.95 1 1.05  1.15  1.2 1.3 1.4 1.5 1.6]*4;-------two
%priority

% traffic 1 is always 0



for traf=1:1
    link_use=zeros(L,C,1,6);
    total = 4e5;
    lambda2=OD*0*C;   %not used, set to 0
    lambda3=OD*0.015*C;  %only use this one
    mu2 =1;   mu3=1;
    r2=1;
    r3=5;

    Threshold2=C;
    Threshold3=C;
    block2=0; block3=0; block4=0;
    arrival2=0;
    arrival3=0;

    arrivelIntervalTime(1:total) = exprnd(1/(lambda2+lambda3),[1,total]);

    nextArrivalTime=arrivelIntervalTime(1);
    rd=rand();




    if rd<(lambda2)/(lambda2+lambda3)
        nextArrivalClass=2;
        %serviceTime=delta_cus1/((1-rand())^(1/r_cus));
        serviceTime=exprnd(1/(mu2),1);
        arrival2=arrival2+1;
    else
        nextArrivalClass=3;
        arrival3=arrival3+1;
        %serviceTime=delta_cus2/((1-rand())^(1/r_cus));
        serviceTime=exprnd(1/(mu3),1);

    end

    nextODNo=floor(rand()*OD+1);
    link=OD_path(nextODNo,1,1);

    inService(nextODNo,1,1)=nextArrivalTime+serviceTime;
    if nextArrivalClass==2
        for jjj=1:r2
            link_use(link,jjj,1:6)=[1 nextArrivalClass nextODNo 1 nextArrivalTime+serviceTime serviceTime];
        end
    else
        for jjj=1:r3
            link_use(link,jjj,1:6)=[1 nextArrivalClass nextODNo 1 nextArrivalTime+serviceTime serviceTime];
        end
    end

    arrival=1;
    nextArrivalTime=nextArrivalTime+arrivelIntervalTime(arrival+1);
    %find the min departure time
    nextDepartureTime=min(inService(find(inService(:,:,:)>0)));
    if length(nextDepartureTime)==0
        nextDepartureTime=1e20;
    end

    while arrival<(total-2)
        if  nextDepartureTime <= nextArrivalTime
            %departure happens

            %release the resource in trunks
            x=find (link_use(:,:,1,5)==nextDepartureTime);
            for i=1:length(x)
                column=ceil(x(i)/L);
                row=x(i)-L*(column-1);
                link_use(row,column,1,1:6)=[0 0 0 0 0 0];
            end
            %release the service
            x=find(inService(:,:,:)==nextDepartureTime);
            inService(x)=0;
            %find the next min departure time
            nextDepartureTime=min(inService(find(inService(:,:,:)>0)));
            if (length(nextDepartureTime)==0)
                nextDepartureTime=1e20;
            end
        else
            %%%%%%%%%%%%%%%%%% an arrivel
            rd=rand();

            if rd<(lambda2)/(lambda2+lambda3)
                nextArrivalClass=2;
                %serviceTime=delta_cus1/((1-rand())^(1/r_cus));
                serviceTime=exprnd(1/(mu2),1);
                arrival2=arrival2+1;
            else
                nextArrivalClass=3;
                arrival3=arrival3+1;
                %serviceTime=delta_cus2/((1-rand())^(1/r_cus));
                serviceTime=exprnd(1/(mu3),1);
            end

            nextODNo=floor(rand()*OD+1);





            %%%%%%%%%%%%%%%priority 3 call arrival
            if (nextArrivalClass==3)
                pathLength=length(find(OD_path(nextODNo,1,:)>0));
                link=zeros(1,pathLength);
                link=OD_path(nextODNo,1,1:pathLength);
                channel=zeros(length(link),C);
                OK=1;
                for i=1:length(link)
                    x=find( link_use(link(i),:,1,1)==0);
                    if length(x)>=r3
                        channel(i,1:length(x))=x;
                    else
                        OK=0;
                    end
                end
                if OK==1
                    %the primary path  is free
                    for i=1:length(link)
                        for jjj=1:r3
                            link_use(link(i),channel(i,jjj),1,1:6)=[1 3 nextODNo 1  nextArrivalTime+serviceTime serviceTime];
                        end
                    end

                    if (nextArrivalTime+serviceTime)<nextDepartureTime
                        nextDepartureTime=nextArrivalTime+serviceTime;
                    end
                    freeSlot=find(inService(nextODNo,1,:)==0);
                    inService(nextODNo,1,freeSlot(1))=nextArrivalTime+serviceTime;
                    %                         arrival=arrival+1;
                    %                         nextArrivalTime=nextArrivalTime+arrivelIntervalTime(arrival+1);

                else
                    k=2;
                    finish=0;
                    while (k<D+2 && finish==0);

                        % k-1 overflow path
                        pathLength=length(find(OD_path(nextODNo,k,:)>0));
                        link=zeros(1,pathLength);
                        link=OD_path(nextODNo,k,1:pathLength);
                        channel=zeros(length(link),C);
                        OK=1;% the path is free
                        for i=1:length(link)
                            x=find( link_use(link(i),:,1,1)==0);
                            if (length(x)>=(C-Threshold3+r3))


                                channel(i,1:length(x))=x;
                            else
                                OK=0;
                            end
                        end
                        if OK==1
                            for i=1:length(link)
                                for jjj=1:r3
                                    link_use(link(i),channel(i,jjj),1,1:6)=[1 3 nextODNo k  nextArrivalTime+serviceTime serviceTime];
                                end
                            end
                            if (nextArrivalTime+serviceTime)<nextDepartureTime
                                nextDepartureTime=nextArrivalTime+serviceTime;
                            end
                            freeSlot=find(inService(nextODNo,k,:)==0);
                            inService(nextODNo,k,freeSlot(1))=nextArrivalTime+serviceTime;
                            finish=1;
                           
                        else
                            k=k+1;
                        end
                    end
                    if finish==0
                        block3=block3+1;
                      
                    end
                end
            else
                %%%%%%%%%%%%priority 2 calss arrival
                pathLength=length(find(OD_path(nextODNo,1,:)>0));
                link=zeros(1,pathLength);
                link=OD_path(nextODNo,1,1:pathLength);
                channel=zeros(length(link),C);
                OK=1;
                for i=1:length(link)
                    x=find( link_use(link(i),:,1,1)==0 );
                    if length(x)>=r2
                        channel(i,1:length(x))=x;
                    else
                        OK=0;
                    end
                end
                if OK==1
                    %the primary path  is free
                    for i=1:length(link)
                        for jjj=1:r2
                            link_use(link(i),channel(i,jjj),1,1:6)=[1 2 nextODNo 1  nextArrivalTime+serviceTime serviceTime];
                        end
                    end

                    if (nextArrivalTime+serviceTime)<nextDepartureTime
                        nextDepartureTime=nextArrivalTime+serviceTime;
                    end
                    freeSlot=find(inService(nextODNo,1,:)==0);
                    inService(nextODNo,1,freeSlot(1))=nextArrivalTime+serviceTime;
                else
                    k=2;
                    finish=0;
                    while (k<D+2 && finish==0);

                        % k-1 overflow path
                        pathLength=length(find(OD_path(nextODNo,k,:)>0));
                        link=zeros(1,pathLength);
                        link=OD_path(nextODNo,k,1:pathLength);
                        channel=zeros(length(link),C);
                        OK=1;% the path is free
                        for i=1:length(link)
                            x=find( link_use(link(i),:,1,1)==0 );
                            if (length(x)>=(C-Threshold3+r2))


                                channel(i,1:length(x))=x;
                            else
                                OK=0;
                            end
                        end
                        if OK==1
                            for i=1:length(link)
                                for jjj=1:r2
                                    link_use(link(i),channel(i,jjj),1,1:6)=[1 2 nextODNo k  nextArrivalTime+serviceTime serviceTime];
                                end
                            end
                            if (nextArrivalTime+serviceTime)<nextDepartureTime
                                nextDepartureTime=nextArrivalTime+serviceTime;
                            end
                            freeSlot=find(inService(nextODNo,k,:)==0);
                            inService(nextODNo,k,freeSlot(1))=nextArrivalTime+serviceTime;
                            finish=1;
                            
                        else
                            k=k+1;
                        end
                    end
                    if finish==0
                        block2=block2+1;
                        %                             arrival=arrival+1;
                        %                             nextArrivalTime=nextArrivalTime+arrivelIntervalTime(arrival+1);
                    end
                end

            end
            arrival=arrival+1;
            nextArrivalTime=nextArrivalTime+arrivelIntervalTime(arrival+1);
        end
    end
block2
block3
b2(traf)=block2/arrival2
b3(traf)=block3/arrival3
end

                    
        






